program mpo2jpg;

uses
  Windows, SysUtils, Classes;

procedure CopyJpegFrom(Src, Dst: TStream);
var
  Buffer: PByteArray;
  Size: Integer;
begin
  GetMem(Buffer,$10000);
  try
    while TRUE do
    begin
      FillChar(Buffer^,4,#0);
      Src.Read(Buffer^,4);
      Size:= ((Buffer[2] shl 8) + Buffer[3]) - 2;
      case Buffer[1] of
        $01,$D0..$D8: begin
                        Dst.WriteBuffer(Buffer^,2);
                        Src.Seek(-2,soFromCurrent);
                      end;
        $D9: begin
               Dst.WriteBuffer(Buffer^,2);
               Exit;
             end;
        $DA: begin
               Dst.WriteBuffer(Buffer^,2);
               Src.Seek(-2,soFromCurrent);
               while TRUE do
               begin
                 Src.ReadBuffer(Buffer^,1);
                 if Buffer[0] = $FF then
                 begin
                   Src.ReadBuffer(Buffer^,1);
                  if (Buffer[0] <> 0) and not (Buffer[0] in [$D0..$D7]) then
                   begin
                     Src.Seek(-2,soFromCurrent);
                     break;
                   end else
                   begin
                     Buffer[1]:= Buffer[0];
                     Buffer[0]:= $FF;
                     Dst.WriteBuffer(Buffer^,2);
                   end;
                 end else
                   Dst.WriteBuffer(Buffer^,1);
               end;
             end
        else
        begin
          Dst.WriteBuffer(Buffer^,4);
          Src.ReadBuffer(Buffer^,Size);
          Dst.WriteBuffer(Buffer^,Size);
        end;
      end;
    end;
  finally
    FreeMem(Buffer);
  end;
end;

procedure SaveJpegToFile(Src: TStream; Filename: String);
var
  Stream: TMemoryStream;
begin
  Stream:= TMemoryStream.Create;
  try
    CopyJpegFrom(Src, Stream);
    Stream.SaveToFile(Filename);
  finally
    Stream.Free;
  end;
end;
 
procedure ScanFile(Stream: TStream; FormatStr: String; Index: Integer; Full: Boolean); overload;
var
  B: Byte;
  Leidos: Integer;
  Posicion: int64;
  Str: String;
begin
  // Leemos byte a byte hasta encontrar la marca de inicio
  Leidos:= Stream.Read(B,1);
  while Leidos = 1 do
    if B = $FF then
    begin
      Leidos:= Stream.Read(B,1);
      if Leidos = 1 then
        if B = $D8 then
        begin
          Leidos:= Stream.Read(B,1);
          if Leidos = 1 then
            if B = $FF then
            begin
              // Encontramos la marca de inicio
              Posicion:= Stream.Position;
              Stream.Seek(-3,soFromCurrent);
              Str:= Format(FormatStr,[index]);
              try
                // Intentamos extraer la imagen
                SaveJpegToFile(Stream,Str);
                inc(index);
              except
                // Si se produce un error volvemos atras y continuamos buscando
                On E: Exception do
                begin
                   Stream.Position:= Posicion;
                end;
              end;
              // Si la busqueda es "completa", extraemos tambien los thumbnails
              if Full then              
                Stream.Position:= Posicion;
            end;
        end;
    end else
      Leidos:= Stream.Read(B,1);
end;

var
  Src: TMemoryStream;

begin
  if ParamCount = 0 then
    Exit;
  try
    Src:= TMemoryStream.Create;
    try
      // Cargamos el archivo en memoria
      Src.LoadFromFile(ParamStr(1));
      // Exploramos el archivo cargado en la memoria
      ScanFile(Src,ChangeFileExt(ParamStr(1),'_%d.jpg'),1,FALSE);
    finally
      Src.Free;
    end;
  except
    On E: Exception do
    begin
       // Si tenemos algun error lo mostramos
       MessageBox(0,PChar(E.Message),'Error',MB_ICONERROR or MB_SETFOREGROUND
         or MB_TASKMODAL or MB_OK);
    end;
  end;
end.
